# Concepts

- [Steps & Pipelines](https://docs.zenml.io/concepts/steps_and_pipelines.md): Steps and Pipelines are the core building blocks of ZenML
- [Configuration](https://docs.zenml.io/concepts/steps_and_pipelines/configuration.md): Configuring and customizing your pipeline runs.
- [Scheduling](https://docs.zenml.io/concepts/steps_and_pipelines/scheduling.md): Learn how to create, update, activate, deactivate, and delete schedules for pipelines.
- [Logging](https://docs.zenml.io/concepts/steps_and_pipelines/logging.md): Learn how to control and customize logging behavior in ZenML pipelines.
- [YAML Configuration](https://docs.zenml.io/concepts/steps_and_pipelines/yaml_configuration.md): Learn how to configure ZenML pipelines using YAML configuration files.
- [Source Code and Imports](https://docs.zenml.io/concepts/steps_and_pipelines/sources.md): Understanding source roots and source paths
- [Execution](https://docs.zenml.io/concepts/steps_and_pipelines/execution.md): Step and pipeline execution.
- [Wait for External Input](https://docs.zenml.io/concepts/steps_and_pipelines/wait_resume.md): Pause a dynamic pipeline for external input and resume it after the input is resolved.
- [Advanced Features](https://docs.zenml.io/concepts/steps_and_pipelines/advanced_features.md): Advanced features and capabilities of ZenML pipelines and steps
- [Dynamic Pipelines](https://docs.zenml.io/concepts/steps_and_pipelines/dynamic_pipelines.md): Write dynamic pipelines
- [Artifacts](https://docs.zenml.io/concepts/artifacts.md): Learn how ZenML manages data artifacts, tracks versioning and lineage, and enables effective data flow between steps.
- [Materializers](https://docs.zenml.io/concepts/artifacts/materializers.md): Understanding and creating materializers to handle custom data types in ZenML pipelines
- [Visualizations](https://docs.zenml.io/concepts/artifacts/visualizations.md): Learn how to visualize the data artifacts produced by your ZenML pipelines.
- [Stack & Components](https://docs.zenml.io/concepts/stack_components.md): Understanding and working with ZenML Stacks and Stack Components
- [Service Connectors](https://docs.zenml.io/concepts/service_connectors.md): Managing authentication to cloud services and resources with Service Connectors
- [Pipeline Snapshots](https://docs.zenml.io/concepts/snapshots.md): Create and run pipeline snapshots.
- [Pipeline Deployments](https://docs.zenml.io/concepts/deployment.md): Deploy pipelines as HTTP services for real-time execution
- [Deployment Settings](https://docs.zenml.io/concepts/deployment/deployment_settings.md): Customize the pipeline deployment ASGI application with DeploymentSettings.
- [Containerization](https://docs.zenml.io/concepts/containerization.md): Customize Docker builds to run your pipelines in isolated, well-defined environments.
- [Code Repositories](https://docs.zenml.io/concepts/code-repositories.md): Tracking your code and avoiding unnecessary Docker builds by connecting your git repo.
- [Secrets](https://docs.zenml.io/concepts/secrets.md): Registering and using secrets.
- [Environment Variables](https://docs.zenml.io/concepts/environment-variables.md): Configuring environment variables.
- [Tags](https://docs.zenml.io/concepts/tags.md): Use tags to organize tags in ZenML.
- [Metadata](https://docs.zenml.io/concepts/metadata.md): Enrich your ML workflow with contextual information using ZenML metadata.
- [Models](https://docs.zenml.io/concepts/models.md): Managing ML models throughout their lifecycle with ZenML
- [Dashboard](https://docs.zenml.io/concepts/dashboard-features.md): Explore the features and capabilities of the ZenML dashboard
- [Templates](https://docs.zenml.io/concepts/templates.md): Create and run templates in ZenML to standardize execution.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.zenml.io/concepts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
